searchNodes=[{"doc":"","ref":"Mix.Tasks.Terminator.UUID.html","title":"Mix.Tasks.Terminator.UUID","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Terminator.UUID.html#run/1","title":"Mix.Tasks.Terminator.UUID.run/1","type":"function"},{"doc":"After configuring your default ecto repo in :ecto_repos Run mix Terminator.UUID.install to generates a setup_terminator_uuid_tables migration, which Terminator tables, as well as required indexes.","ref":"Mix.Tasks.Terminator.UUID.Install.html","title":"Mix.Tasks.Terminator.UUID.Install","type":"task"},{"doc":"","ref":"Mix.Tasks.Terminator.UUID.Install.html#run/1","title":"Mix.Tasks.Terminator.UUID.Install.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Terminator.UUID.Setup.html","title":"Mix.Tasks.Terminator.UUID.Setup","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Terminator.UUID.Setup.html#run/1","title":"Mix.Tasks.Terminator.UUID.Setup.run/1","type":"function"},{"doc":"","ref":"Post.html","title":"Post","type":"module"},{"doc":"Main Terminator module for including macros Terminator has 3 main components: Terminator.UUID.Ability - Representation of a single permission e.g. :view, :delete, :update Terminator.UUID.Performer - Main actor which is holding given abilities Terminator.UUID.Role - Grouped set of multiple abilities, e.g. :admin, :manager, :editor Relations between models Terminator.UUID.Performer -&gt; Terminator.UUID.Ability [1-n] - Any given performer can hold multiple abilities this allows you to have very granular set of abilities per each performer Terminator.UUID.Performer -&gt; Terminator.UUID.Role [1-n] - Any given performer can act as multiple roles this allows you to manage multple sets of abilities for multiple performers at once Terminator.UUID.Role -&gt; Terminator.UUID.Ability [m-n] - Any role can have multiple abilities therefore you can have multiple roles to have different/same abilities Calculating abilities Calculation of abilities is done by OR and DISTINCT abilities. That means if you have Role[:admin, abilities: [:delete]] , Role[:editor, abilities: [:update]] , Role[:user, abilities: [:view]] and all roles are granted to single performer, resulting abilities will be [:delete, :update, :view] Available permissions Terminator.UUID.has_ability/1 - Requires single ability to be present on performer Terminator.UUID.has_role/1 - Requires single role to be present on performer","ref":"Terminator.UUID.html","title":"Terminator.UUID","type":"module"},{"doc":"Macro for wrapping protected code Example defmodule HelloTest do use Terminator.UUID def test_authorization do as_authorized do IO . inspect ( &quot;This code is executed only for authorized performer&quot; ) end end end","ref":"Terminator.UUID.html#as_authorized/1","title":"Terminator.UUID.as_authorized/1","type":"macro"},{"doc":"Defines calculated permission to be evaluated in runtime Examples defmodule HelloTest do use Terminator.UUID def test_authorization do permissions do calculated ( fn performer -&gt; performer . email_confirmed? end ) end as_authorized do IO . inspect ( &quot;This code is executed only for authorized performer&quot; ) end end end You can also use DSL form which takes function name as argument defmodule HelloTest do use Terminator.UUID def test_authorization do permissions do calculated ( :email_confirmed ) end as_authorized do IO . inspect ( &quot;This code is executed only for authorized performer&quot; ) end end def email_confirmed ( performer ) do performer . email_confirmed? end end For more complex calculation you need to pass bindings to the function defmodule HelloTest do use Terminator.UUID def test_authorization do post = % Post { owner_id : 1 } permissions do calculated ( :is_owner , [ post ] ) calculated ( fn performer , [ post ] -&gt; post . owner_id == performer . id end ) end as_authorized do IO . inspect ( &quot;This code is executed only for authorized performer&quot; ) end end def is_owner ( performer , [ post ] ) do post . owner_id == performer . id end end","ref":"Terminator.UUID.html#calculated/1","title":"Terminator.UUID.calculated/1","type":"macro"},{"doc":"","ref":"Terminator.UUID.html#calculated/2","title":"Terminator.UUID.calculated/2","type":"macro"},{"doc":"Requires an ability within permissions block Example defmodule HelloTest do use Terminator.UUID def test_authorization do permissions do has_ability ( :can_run_test_authorization ) end end end","ref":"Terminator.UUID.html#has_ability/1","title":"Terminator.UUID.has_ability/1","type":"function"},{"doc":"","ref":"Terminator.UUID.html#has_ability/2","title":"Terminator.UUID.has_ability/2","type":"function"},{"doc":"Perform authorization on passed performer and abilities","ref":"Terminator.UUID.html#has_ability?/2","title":"Terminator.UUID.has_ability?/2","type":"function"},{"doc":"","ref":"Terminator.UUID.html#has_ability?/3","title":"Terminator.UUID.has_ability?/3","type":"function"},{"doc":"Requires a role within permissions block Example defmodule HelloTest do use Terminator.UUID def test_authorization do permissions do has_role ( :admin ) end end end","ref":"Terminator.UUID.html#has_role/1","title":"Terminator.UUID.has_role/1","type":"function"},{"doc":"Perform role check on passed performer and role","ref":"Terminator.UUID.html#has_role?/2","title":"Terminator.UUID.has_role?/2","type":"function"},{"doc":"Returns authorization result on collected performer and required roles/abilities Example defmodule HelloTest do use Terminator.UUID def test_authorization do case is_authorized? do :ok -&gt; &quot;Performer is authorized&quot; { :error , message : _message } -&gt; &quot;Performer is not authorized&quot; end end","ref":"Terminator.UUID.html#is_authorized?/0","title":"Terminator.UUID.is_authorized?/0","type":"function"},{"doc":"Macro for defining required permissions Example defmodule HelloTest do use Terminator.UUID def test_authorization do permissions do has_role ( :admin ) has_ability ( :view ) end end end","ref":"Terminator.UUID.html#permissions/1","title":"Terminator.UUID.permissions/1","type":"macro"},{"doc":"Resets ETS table","ref":"Terminator.UUID.html#reset_session/0","title":"Terminator.UUID.reset_session/0","type":"function"},{"doc":"","ref":"Terminator.UUID.Config.html","title":"Terminator.UUID.Config","type":"module"},{"doc":"","ref":"Terminator.UUID.Config.html#config/0","title":"Terminator.UUID.Config.config/0","type":"function"},{"doc":"Return value by key from config.exs file.","ref":"Terminator.UUID.Config.html#get/2","title":"Terminator.UUID.Config.get/2","type":"function"},{"doc":"","ref":"Terminator.UUID.Config.html#key_type/0","title":"Terminator.UUID.Config.key_type/0","type":"function"},{"doc":"","ref":"Terminator.UUID.Config.html#key_type/1","title":"Terminator.UUID.Config.key_type/1","type":"function"},{"doc":"","ref":"Terminator.UUID.Config.html#repo/0","title":"Terminator.UUID.Config.repo/0","type":"function"},{"doc":"","ref":"Terminator.UUID.Config.html#repos/0","title":"Terminator.UUID.Config.repos/0","type":"function"},{"doc":"Ecto repository","ref":"Terminator.UUID.Repo.html","title":"Terminator.UUID.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/3 .","ref":"Terminator.UUID.Repo.html#aggregate/3","title":"Terminator.UUID.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"Terminator.UUID.Repo.html#aggregate/4","title":"Terminator.UUID.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"Terminator.UUID.Repo.html#all/2","title":"Terminator.UUID.Repo.all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checked_out?/0 .","ref":"Terminator.UUID.Repo.html#checked_out?/0","title":"Terminator.UUID.Repo.checked_out?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checkout/2 .","ref":"Terminator.UUID.Repo.html#checkout/2","title":"Terminator.UUID.Repo.checkout/2","type":"function"},{"doc":"","ref":"Terminator.UUID.Repo.html#child_spec/1","title":"Terminator.UUID.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"Terminator.UUID.Repo.html#config/0","title":"Terminator.UUID.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.default_options/1 .","ref":"Terminator.UUID.Repo.html#default_options/1","title":"Terminator.UUID.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"Terminator.UUID.Repo.html#delete!/2","title":"Terminator.UUID.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"Terminator.UUID.Repo.html#delete/2","title":"Terminator.UUID.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"Terminator.UUID.Repo.html#delete_all/2","title":"Terminator.UUID.Repo.delete_all/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that forces all connections in the pool to disconnect within the given interval. See Ecto.Adapters.SQL.disconnect_all/3 for more information.","ref":"Terminator.UUID.Repo.html#disconnect_all/2","title":"Terminator.UUID.Repo.disconnect_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.exists?/2 .","ref":"Terminator.UUID.Repo.html#exists?/2","title":"Terminator.UUID.Repo.exists?/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query. See Ecto.Adapters.SQL.explain/4 for more information.","ref":"Terminator.UUID.Repo.html#explain/3","title":"Terminator.UUID.Repo.explain/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"Terminator.UUID.Repo.html#get!/3","title":"Terminator.UUID.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"Terminator.UUID.Repo.html#get/3","title":"Terminator.UUID.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"Terminator.UUID.Repo.html#get_by!/3","title":"Terminator.UUID.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"Terminator.UUID.Repo.html#get_by/3","title":"Terminator.UUID.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0 .","ref":"Terminator.UUID.Repo.html#get_dynamic_repo/0","title":"Terminator.UUID.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"Terminator.UUID.Repo.html#in_transaction?/0","title":"Terminator.UUID.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"Terminator.UUID.Repo.html#insert!/2","title":"Terminator.UUID.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"Terminator.UUID.Repo.html#insert/2","title":"Terminator.UUID.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"Terminator.UUID.Repo.html#insert_all/3","title":"Terminator.UUID.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"Terminator.UUID.Repo.html#insert_or_update!/2","title":"Terminator.UUID.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"Terminator.UUID.Repo.html#insert_or_update/2","title":"Terminator.UUID.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"Terminator.UUID.Repo.html#load/2","title":"Terminator.UUID.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"Terminator.UUID.Repo.html#one!/2","title":"Terminator.UUID.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"Terminator.UUID.Repo.html#one/2","title":"Terminator.UUID.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"Terminator.UUID.Repo.html#preload/3","title":"Terminator.UUID.Repo.preload/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.prepare_query/3 .","ref":"Terminator.UUID.Repo.html#prepare_query/3","title":"Terminator.UUID.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1 .","ref":"Terminator.UUID.Repo.html#put_dynamic_repo/1","title":"Terminator.UUID.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"Terminator.UUID.Repo.html#query!/3","title":"Terminator.UUID.Repo.query!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"Terminator.UUID.Repo.html#query/3","title":"Terminator.UUID.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many!/4 for more information.","ref":"Terminator.UUID.Repo.html#query_many!/3","title":"Terminator.UUID.Repo.query_many!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many/4 for more information.","ref":"Terminator.UUID.Repo.html#query_many/3","title":"Terminator.UUID.Repo.query_many/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload!/2 .","ref":"Terminator.UUID.Repo.html#reload!/2","title":"Terminator.UUID.Repo.reload!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload/2 .","ref":"Terminator.UUID.Repo.html#reload/2","title":"Terminator.UUID.Repo.reload/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"Terminator.UUID.Repo.html#rollback/1","title":"Terminator.UUID.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"Terminator.UUID.Repo.html#start_link/1","title":"Terminator.UUID.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/1 .","ref":"Terminator.UUID.Repo.html#stop/1","title":"Terminator.UUID.Repo.stop/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"Terminator.UUID.Repo.html#stream/2","title":"Terminator.UUID.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"Terminator.UUID.Repo.html#to_sql/2","title":"Terminator.UUID.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"Terminator.UUID.Repo.html#transaction/2","title":"Terminator.UUID.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"Terminator.UUID.Repo.html#update!/2","title":"Terminator.UUID.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"Terminator.UUID.Repo.html#update/2","title":"Terminator.UUID.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"Terminator.UUID.Repo.html#update_all/3","title":"Terminator.UUID.Repo.update_all/3","type":"function"},{"doc":"","ref":"Terminator.UUID.Repo.Null.html","title":"Terminator.UUID.Repo.Null","type":"module"},{"doc":"","ref":"Terminator.UUID.Repo.Null.html#all/1","title":"Terminator.UUID.Repo.Null.all/1","type":"function"},{"doc":"","ref":"Terminator.UUID.Repo.Null.html#all/2","title":"Terminator.UUID.Repo.Null.all/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Terminator.UUID.Repo.Null.html#child_spec/1","title":"Terminator.UUID.Repo.Null.child_spec/1","type":"function"},{"doc":"","ref":"Terminator.UUID.Repo.Null.html#get_by!/2","title":"Terminator.UUID.Repo.Null.get_by!/2","type":"function"},{"doc":"","ref":"Terminator.UUID.Repo.Null.html#get_by/2","title":"Terminator.UUID.Repo.Null.get_by/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Terminator.UUID.Repo.Null.html#init/1","title":"Terminator.UUID.Repo.Null.init/1","type":"function"},{"doc":"","ref":"Terminator.UUID.Repo.Null.html#one/2","title":"Terminator.UUID.Repo.Null.one/2","type":"function"},{"doc":"","ref":"Terminator.UUID.Repo.Null.html#start_link/1","title":"Terminator.UUID.Repo.Null.start_link/1","type":"function"},{"doc":"Ability is main representation of a single permission","ref":"Terminator.UUID.Ability.html","title":"Terminator.UUID.Ability","type":"module"},{"doc":"","ref":"Terminator.UUID.Ability.html#build/2","title":"Terminator.UUID.Ability.build/2","type":"function"},{"doc":"","ref":"Terminator.UUID.Ability.html#changeset/2","title":"Terminator.UUID.Ability.changeset/2","type":"function"},{"doc":"An ability struct","ref":"Terminator.UUID.Ability.html#t:t/0","title":"Terminator.UUID.Ability.t/0","type":"type"},{"doc":"Performer is a main actor for determining abilities","ref":"Terminator.UUID.Performer.html","title":"Terminator.UUID.Performer","type":"module"},{"doc":"","ref":"Terminator.UUID.Performer.html#changeset/2","title":"Terminator.UUID.Performer.changeset/2","type":"function"},{"doc":"Grant given grant type to a performer. Examples Function accepts either Terminator.UUID.Ability or Terminator.UUID.Role grants. Function is merging existing grants with the new ones, so calling grant with same grants will not duplicate entries in table. To grant particular ability to a given performer iex&gt; Terminator.UUID.Performer . grant ( % Terminator.UUID.Performer { id : 1 } , % Terminator.UUID.Ability { id : 1 } ) To grant particular role to a given performer iex&gt; Terminator.UUID.Performer . grant ( % Terminator.UUID.Performer { id : 1 } , % Terminator.UUID.Role { id : 1 } )","ref":"Terminator.UUID.Performer.html#grant/2","title":"Terminator.UUID.Performer.grant/2","type":"function"},{"doc":"","ref":"Terminator.UUID.Performer.html#grant/3","title":"Terminator.UUID.Performer.grant/3","type":"function"},{"doc":"","ref":"Terminator.UUID.Performer.html#load_performer_entities/2","title":"Terminator.UUID.Performer.load_performer_entities/2","type":"function"},{"doc":"Revoke given grant type from a performer. Examples Function accepts either Terminator.UUID.Ability or Terminator.UUID.Role grants. Function is directly opposite of Terminator.UUID.Performer.grant/2 To revoke particular ability from a given performer iex&gt; Terminator.UUID.Performer . revoke ( % Terminator.UUID.Performer { id : 1 } , % Terminator.UUID.Ability { id : 1 } ) To revoke particular role from a given performer iex&gt; Terminator.UUID.Performer . revoke ( % Terminator.UUID.Performer { id : 1 } , % Terminator.UUID.Role { id : 1 } )","ref":"Terminator.UUID.Performer.html#revoke/2","title":"Terminator.UUID.Performer.revoke/2","type":"function"},{"doc":"","ref":"Terminator.UUID.Performer.html#revoke/3","title":"Terminator.UUID.Performer.revoke/3","type":"function"},{"doc":"","ref":"Terminator.UUID.Performer.html#table/0","title":"Terminator.UUID.Performer.table/0","type":"function"},{"doc":"A performer struct","ref":"Terminator.UUID.Performer.html#t:t/0","title":"Terminator.UUID.Performer.t/0","type":"type"},{"doc":"Role is grouped representation of multiple abilities. It allows you to assign or manage multiple roles at once.","ref":"Terminator.UUID.Role.html","title":"Terminator.UUID.Role","type":"module"},{"doc":"Builds ecto changeset for a role. Examples iex&gt; changeset = Terminator.UUID.Role . build ( &quot;admin&quot; , [ &quot;delete_account&quot; ] , &quot;Administrator of application&quot; ) # Ecto.Changeset &lt; action : nil , changes : %{ abilities : [ &quot;delete_account&quot; ] , identifier : &quot;admin&quot; , name : &quot;Administrator of application&quot; } , errors : [ ] , data : # Terminator.UUID.Role &lt; &gt; , valid? : true &gt; iex&gt; changeset |&gt; Repo . insert { :ok , % Terminator.UUID.Role { __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;terminator_uuid_roles&quot; &gt; , abilities : [ &quot;delete_account&quot; ] , id : 1 , identifier : &quot;admin&quot; , inserted_at : ~N[2019-01-03 19:50:13] , name : &quot;Administrator of application&quot; , updated_at : ~N[2019-01-03 19:50:13] } }","ref":"Terminator.UUID.Role.html#build/3","title":"Terminator.UUID.Role.build/3","type":"function"},{"doc":"","ref":"Terminator.UUID.Role.html#changeset/2","title":"Terminator.UUID.Role.changeset/2","type":"function"},{"doc":"Grant Terminator.UUID.Ability to a role. Examples Function accepts Terminator.UUID.Ability grant. Function is merging existing grants with the new ones, so calling grant with same grants will not duplicate entries in table. To grant particular ability to a role iex&gt; Terminator.UUID.Performer . grant ( % Terminator.UUID.Role { id : 1 } , % Terminator.UUID.Ability { identifier : &quot;manage&quot; } )","ref":"Terminator.UUID.Role.html#grant/2","title":"Terminator.UUID.Role.grant/2","type":"function"},{"doc":"Revoke Terminator.UUID.Ability from a role. Examples Function accepts Terminator.UUID.Ability grant. Function is directly opposite of Terminator.UUID.Role.grant/2 To revoke particular ability from a given role iex&gt; Terminator.UUID.Performer . revoke ( % Terminator.UUID.Role { id : 1 } , % Terminator.UUID.Ability { identifier : &quot;manage&quot; } )","ref":"Terminator.UUID.Role.html#revoke/2","title":"Terminator.UUID.Role.revoke/2","type":"function"},{"doc":"A role struct","ref":"Terminator.UUID.Role.html#t:t/0","title":"Terminator.UUID.Role.t/0","type":"type"},{"doc":"Terminator is toolkit for granular ability management for performers. This differs from terminator in now we have user selectable id key associations use uuid or integer It allows you to define granular abilities such as: Performer -&gt; Ability Performer -&gt; [Ability, Ability, ...] Role -&gt; [Ability, Ability, ...] Performer -&gt; Role -&gt; [Ability, Ability, Ability] Performer -&gt; [Role -&gt; [Ability], Role -&gt; [Ability, ...]] Performer -&gt; AnyEntity -&gt; [Ability, ...] It tries to mimic https://en.wikipedia.org/wiki/Attribute-based_access_control and allow to define any policy which is needed. Here is a small example: defmodule Sample.Post use Terminator def delete_post ( uuid , performer_uuid \\\\ Ecto.UUID . bingenerate ( ) ) do performer = Terminator.Repo . get ( Terminator.UUID.Performer , performer_uuid ) load_and_authorize_performer ( performer ) post = % Post { id : uuid } permissions do has_role ( :admin ) # or has_role ( :editor ) # or has_ability ( :delete_posts ) # or has_ability ( :delete , post ) # Entity related abilities calculated ( fn performer -&gt; performer . email_confirmed? end ) end as_authorized do Sample.Repo . get ( Sample.Post , uuid ) |&gt; Sample . repo . delete ( ) end # Notice that you can use both macros or functions case is_authorized? do :ok -&gt; Sample.Repo . get ( Sample.Post , uuid ) |&gt; Sample . repo . delete ( ) { :error , message } -&gt; &quot;Raise error&quot; _ -&gt; &quot;Raise error&quot; end end","ref":"readme.html","title":"🛡 Terminator with uuid 🛡","type":"extras"},{"doc":"[x] Performer -&gt; [Ability] permission schema [x] Role -&gt; [Ability] permission schema [x] Performer -&gt; [Role] -&gt; [Ability] permission schema [x] Performer -&gt; Object -&gt; [Ability] permission schema [x] Computed permission in runtime [x] Easily readable DSL [ ] ueberauth integration [ ] absinthe middleware [ ] Session plug to get current_user","ref":"readme.html#features","title":"🛡 Terminator with uuid 🛡 - Features","type":"extras"},{"doc":"def deps do [ { :terminator_uuid , &quot;~&gt; 0.5.5&quot; } ] end # In your config/config.exs file config :terminator_uuid , Terminator.UUID.Repo , username : &quot;postgres&quot; , password : &quot;postgres&quot; , database : &quot;terminator_uuid_dev&quot; , hostname : &quot;localhost&quot; , primary_key_type : :uuid iex&gt; mix terminator . UUID . setup Usage with ecto Terminator is originally designed to be used with Ecto. Usually you will want to have your own table for Accounts / Users living in your application. To do so you can link performer with belongs_to association within your schema. # In your migrations add performer_id field defmodule Sample.Migrations.CreateUsersTable do use Ecto.Migration def change do create table ( :users ) do add :username , :string add :performer_id , references ( Terminator.UUID.Performer . table ( ) , type : :binary_id ) timestamps ( ) end create unique_index ( :users , [ :username ] ) end end This will allow you link any internal entity with 1-1 association to performers. Please note that you need to create performer on each user creation (e.g with Terminator.UUID.Performer.changeset/2 ) and call put_assoc inside your changeset # In schema defintion defmodule Sample.User do use Ecto.Schema schema &quot;users&quot; do field :username , :String belongs_to :performer , Terminator.UUID.Performer timestamps ( ) end end # In your model defmodule Sample.Post use Terminator def delete_post ( uuid , performer_uuid ) do user = Sample.Repo . get ( Sample.User , performer_uuid ) load_and_authorize_performer ( user ) # Function allows multiple signatues of performer it can # be either: # * %Terminator.UUID.Performer{} # * %AnyStruct{performer: %Terminator.UUID.Performer{}} # * %AnyStruct{performer_id: id} (this will perform database preload) permissions do has_role ( :admin ) # or has_role ( :editor ) # or has_ability ( :delete_posts ) # or end as_authorized do Sample.Repo . get ( Sample.Post , uuid ) |&gt; Sample . repo . delete ( ) end # Notice that you can use both macros or functions case is_authorized? do :ok -&gt; Sample.Repo . get ( Sample.Post , uuid ) |&gt; Sample . repo . delete ( ) { :error , message } -&gt; &quot;Raise error&quot; _ -&gt; &quot;Raise error&quot; end end Terminator tries to infer the performer, so it is easy to pass any struct (could be for example User in your application) which has set up belongs_to association for performer. If the performer was already preloaded from database Terminator will take it as loaded performer. If you didn't do preload and just loaded User -&gt; Repo.get(User, 1) Terminator will fetch the performer on each authorization try. Calculated permissions Often you will come to case when static permissions are not enough. For example allow only users who confirmed their email address. defmodule Sample.Post do def create ( uuid , performer_uuid ) do user = Sample.Repo . get ( Sample.User , performer_uuid ) load_and_authorize_performer ( user ) permissions do calculated ( fn performer -&gt; do performer . email_confirmed? end ) end end end We can also use DSL form of calculated keyword defmodule Sample.Post do def create ( uuid , performer_uuid ) do user = Sample.Repo . get ( Sample.User , performer_uuid ) load_and_authorize_performer ( user ) permissions do calculated ( :confirmed_email ) end end def confirmed_email ( performer ) do performer . email_confirmed? end end Composing calculations When we need to performer calculation based on external data we can invoke bindings to calculated/2 defmodule Sample.Post do def create ( uuid , performer_uuid ) do user = Sample.Repo . get ( Sample.User , performer_uuid ) post = % Post { owner_id : uuid } load_and_authorize_performer ( user ) permissions do calculated ( :confirmed_email ) calculated ( :is_owner , [ post ] ) end end def confirmed_email ( performer ) do performer . email_confirmed? end def is_owner ( performer , [ post ] ) do performer . id == post . owner_id end end To perform exclusive abilities such as when User is owner of post AND is in editor role we can do so as in following example defmodule Sample.Post do def create ( performer_uuid ) do user = Sample.Repo . get ( Sample.User , performer_uuid ) post = % Post { owner_id : user . id } load_and_authorize_performer ( user ) permissions do has_role ( :editor ) end as_authorized do case is_owner ( performer , post ) do :ok -&gt; ... { :error , message } -&gt; ... end end end def is_owner ( performer , post ) do load_and_authorize_performer ( performer ) permissions do calculated ( fn p , [ post ] -&gt; p . id == post . owner_id end ) end is_authorized? end end We can simplify example in this case by excluding DSL for permissions defmodule Sample.Post do def create ( uuid , performer_uuid ) do user = Sample.Repo . get ( Sample.User , performer_uuid ) post = % Post { owner_id : user . id } # We can also use has_ability?/2 if has_role? ( user , :admin ) and is_owner ( user , post ) do ... end end def is_owner ( performer , post ) do performer . id == post . owner_id end end Entity related abilities Terminator allows you to grant abilities on any particular struct. Struct needs to have signature of %{__struct__: entity_name, id: entity_id} to infer correct relations. Lets assume that we want to grant :delete ability on particular Post for our performer: iex&gt; { :ok , performer } = % Terminator.UUID.Performer { } |&gt; Terminator.UUID.Repo . insert ( ) iex&gt; post = % Post { id : 1 } iex&gt; ability = % Ability { identifier : &quot;delete&quot; } iex&gt; Terminator.UUID.Performer . grant ( performer , :delete , post ) iex&gt; Terminator.UUID . has_ability? ( performer , :delete , post ) true defmodule Sample.Post do def delete ( post_id , performer_uuid ) do user = Sample.Repo . get ( Sample.User , performer_uuid ) post = % Post { id : post_id } load_and_authorize_performer ( user ) permissions do has_ability ( :delete , post ) end as_authorized do :ok end end end Granting abilities Let's assume we want to create new Role - admin which is able to delete accounts inside our system. We want to have special Performer who is given this role but also he is able to have Ability for banning users. Create performer iex&gt; { :ok , performer } = % Terminator.UUID.Performer { } |&gt; Terminator.UUID.Repo . insert ( ) Create some abilities iex&gt; { :ok , ability_delete } = Terminator.UUID.Ability . build ( &quot;delete_accounts&quot; , &quot;Delete accounts of users&quot; ) |&gt; Terminator.UUID.Repo . insert ( ) iex&gt; { :ok , ability_ban } = Terminator.UUID.Ability . build ( &quot;ban_accounts&quot; , &quot;Ban users&quot; ) |&gt; Terminator.UUID.Repo . insert ( ) Create role iex&gt; { :ok , role } = Terminator.UUID.Role . build ( &quot;admin&quot; , [ ] , &quot;Site administrator&quot; ) |&gt; Terminator.UUID.Repo . insert ( ) Grant abilities to a role iex&gt; Terminator.UUID.Role . grant ( role , ability_delete ) Grant role to a performer iex&gt; Terminator.UUID.Performer . grant ( performer , role ) Grant abilities to a performer iex&gt; Terminator.UUID.Performer . grant ( performer , ability_ban ) iex&gt; performer |&gt; Terminator.UUID.Repo . preload ( [ :roles , :abilities ] ) % Terminator.UUID.Performer { abilities : [ % Terminator.UUID.Ability { identifier : &quot;ban_accounts&quot; } ] roles : [ % Terminator.UUID.Role { identifier : &quot;admin&quot; abilities : [ &quot;delete_accounts&quot; ] } ] } Revoking abilities Same as we can grant any abilities to models we can also revoke them. iex&gt; Terminator.UUID.Performer . revoke ( performer , role ) iex&gt; performer |&gt; Terminator.UUID.Repo . preload ( [ :roles , :abilities ] ) % Terminator.UUID.Performer { abilities : [ % Terminator.UUID.Ability { identifier : &quot;ban_accounts&quot; } ] roles : [ ] } iex&gt; Terminator.UUID.Performer . revoke ( performer , ability_ban ) iex&gt; performer |&gt; Terminator.UUID.Repo . preload ( [ :roles , :abilities ] ) % Terminator.UUID.Performer { abilities : [ ] roles : [ ] }","ref":"readme.html#installation","title":"🛡 Terminator with uuid 🛡 - Installation","type":"extras"},{"doc":"MIT © Milos Mosovsky MIT © Jason Clark","ref":"readme.html#license","title":"🛡 Terminator with uuid 🛡 - License","type":"extras"}]